<script setup>
import { date } from 'alga-js'
const router = useRouter()

definePageMeta({
  middleware: ['auth', 'org']
})

const form = ref({
  id: '',
  client: '',
  clientId: '',
  organization: '',
  organizationId: '',
  name: '',
  description: '',
  isActive: true,
  movementDate: date.now('date'),
  processed: false,
  processedOn: 0,
  documentNo: '',
  productionQty: 0,
  datePromised: date.now('date'),
  isComplete: false,
  isUseProductionPlan: false,
  product: '',
  productId: '',
  isCreated: 'No',
  isCreatedId: 'N',
  project: '',
  projectId: '',
  campaign: '',
  campaignId: '',
  locator: '',
  locatorId: '',
  docStatus: 'Draft',
  docStatusId: 'DR',
  docType: '',
  docTypeId: '',
  processing: false,
  alert: {
    status: '',
    message: ''
  }
})

const back = () => {
  router.push('/manufacturings/productions')
}

const save = async (record, id = '', saveType = '') => {
  const res = await $fetch('/api/manufacturings/productions/store', {
    method: 'POST',
    headers: useRequestHeaders(['cookie']),
    body: {
      organizationId: record.organizationId,
      name: record.name,
      description: record.description,
      isActive: record.isActive,
      movementDate: record.movementDate,
      processed: record.processed,
      processedOn: record.processedOn,
      documentNo: record.documentNo,
      productionQty: record.productionQty,
      datePromised: record.datePromised,
      isComplete: record.isComplete,
      isUseProductionPlan: record.isUseProductionPlan,
      productId: record.productId,
      isCreatedId: record.isCreatedId,
      projectId: record.projectId,
      campaignId: record.campaignId,
      locatorId: record.locatorId,
      docStatusId: record.docStatusId,
      docTypeId: record.docTypeId,
    }
  })

  if(Number(res.status) === 200) {
    if(saveType === 'preview') {
      router.push('/manufacturings/productions/'+res.id+'/view')
    } else if(saveType === 'changes') {
      router.push('/manufacturings/productions/'+res.id+'/edit')
    } else {
      back()
    }
  } else {
    form.value.alert.status = res.status
    form.value.alert.message = res.message
    form.value.processing = false
    window.scrollTo(0, 0)
  }
}

const breadCrumb = computed(() => ([
  { link: '/manufacturings/productions', text: 'Productions'},
  { link: '#', text: 'Add Production', active: true}
]))
</script>

<template>
  <Head>
    <Title>Add Production</Title>
  </Head>

  <NuxtLayout name="new-dash">
    <NewBreadCrumb :items="breadCrumb" />
    <div>
      <div class="banner">
        <div class="d-flex justify-between mb-3">
          <h4></h4>
          <div class="d-flex gap-0.75rem">
            <button type="button" @click="back" class="button">
              <span class="tf-icon ti ti-chevron-left ti-xs me-1"></span> Back
            </button>
          </div>
        </div>
        <div>
          <ManufacturingsProductionForm v-model="form" @save="save"/>
        </div>
      </div>

    </div>
  </NuxtLayout>
</template>